Overview

Getting Started

MARKETPLACE

Widgets

Find Pros

Categories

Keywords

Requests

Leads

Messages

On-Demand Orders

Reviews

User Accounts

PRO INTEGRATIONS

Leads

Messages

Reviews

Pro Profiles

Business Phone Numbers

Manage Webhooks

Testing Your Pro Integration

Support

Changelog

Terms and Policies

Messages

Send and receive real-time messages between customers and pros through webhooks. You can also fetch message history for active leads.

API mapping: In the Thumbtack API, messages are exchanged within a lead, which is called a negotiation. Message endpoints use /api/v4/negotiations/{negotiationID}/messages.

Overview

Messaging allows customers and Pros to chat in order to discuss job details.
The Messages API supports several operations, discussed below.

Get All Messages

You can view all Messages sent as part of a Negotiation via:
GET /api/v4/negotiations/{{negotiationID}}/messages HTTP/2
authorization: Bearer {{authCode}}
{
"data": [
{
"messageID": "519153481515696128",
"negotiationID": "519153480500518912",
"customer": {
"customerID": "519153480034934784",
"displayName": "Olivia Y."
},
"from": "Customer",
"text": "Are you available on my date?",
"attachments": [],
"sentAt": "2024-06-13T17:18:01Z"
}
],
"pagination": {
"limit": 3
}
}

Receive a Message via a Webhook

You can create a webhook for a business if you are integrating for a Business, or create a webhook for a user if you are integrating for a Customer. Both of these approaches allow for Messages to be sent to the specified endpoint in real-time when the Message is created on Thumbtack.

Send a Message to a Negotiation

You can send Messages to a Negotiation via:
POST /api/v4/negotiations/{{negotiationID}}/messages HTTP/2
authorization: Bearer {{authCode}}
content-type: application/json
{
"text": "Hello world"
}

Last Updated: Apr 21st, 2026

On this page